﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MaxWidthonColumnSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable("Table1");
            dt.Columns.Add("Col1", typeof(string));
            dt.Columns.Add("Col2", typeof(string));
            dt.Columns.Add("Col3", typeof(string));
            dt.Columns.Add("Col4", typeof(string));
            dt.Columns.Add("Col5", typeof(string));

            Random random = new Random();
            for (int i = 0; i < 100; i++)
            {
                string[] rowData = new string[5];
                for (int j = 0; j < 5; j++)
                    rowData[j] = random.Next(1000).ToString();

                dt.Rows.Add(rowData);
            }

            this.ultraGrid1.DataSource = dt;

            // Get the columns of Table1 band in the UltraGrid.
            ColumnsCollection gridColumns = this.ultraGrid1.DisplayLayout.Bands["Table1"].Columns;         

            // Allow the user to only resize width of the columns/labels.
            this.ultraGrid1.DisplayLayout.Bands["Table1"].Override.AllowRowLayoutCellSizing = RowLayoutSizing.Horizontal;

            //Set MaxWidth for Col1    
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Col1"].Width = 75;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Col1"].MaxWidth = 100;

        }

        private void btnSetWidth_Click(object sender, EventArgs e)
        {
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Col1"].Width = 200;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            // Store the layout and root band in member variables for easy reference.
            UltraGridLayout layout = e.Layout;
            UltraGridBand rootBand = layout.Bands[0];

            // Set the RowLayoutStyle to allow groups in RowLayout mode. 
            rootBand.RowLayoutStyle = RowLayoutStyle.GroupLayout;

            // Add a couple of groups.
            UltraGridGroup group1 = rootBand.Groups.Add("Group 1");
            UltraGridGroup group2 = rootBand.Groups.Add("Group 2");

            // Add some sub-groups which will be nested in the main groups. 
            UltraGridGroup subGroup1A = rootBand.Groups.Add("Sub-Group 1A");
            UltraGridGroup subGroup1B = rootBand.Groups.Add("Sub-Group 1B");
            UltraGridGroup subGroup2A = rootBand.Groups.Add("Sub-Group 2A");
            UltraGridGroup subGroup2B = rootBand.Groups.Add("Sub-Group 2B");

            // Assign each sub-group to a parent group
            subGroup1A.RowLayoutGroupInfo.ParentGroup = group1;
            subGroup1B.RowLayoutGroupInfo.ParentGroup = group1;
            subGroup2A.RowLayoutGroupInfo.ParentGroup = group2;
            subGroup2B.RowLayoutGroupInfo.ParentGroup = group2;

            // Assign each column to a group. 
            rootBand.Columns["Col1"].RowLayoutColumnInfo.ParentGroup = subGroup1A;           
            rootBand.Columns["Col2"].RowLayoutColumnInfo.ParentGroup = subGroup1B;
            rootBand.Columns["Col3"].RowLayoutColumnInfo.ParentGroup = subGroup1B;
            rootBand.Columns["Col4"].RowLayoutColumnInfo.ParentGroup = subGroup2A;
            rootBand.Columns["Col5"].RowLayoutColumnInfo.ParentGroup = subGroup2B;            
        }
    }
}
